VERSION='1.20141026'
SELF=$(basename $0)
+# Ensure all files created are accessible only to the current user.
+umask 0077
+
fatal() {
echo "$SELF: fatal: $1" >&2
[ -z $2 ] && exit 1
commit Commit in all repositories
delete <repo> Delete an existing repository
enter <repo> Enter repository; spawn new instance of \$SHELL
+ with \$GIT_DIR set.
foreach [<-g>]
<git command> Execute a command for every repository
help Display this help text
You should add files to your new repository."
exit
fi
- GIT_VERSION_MAJOR=$(git --version | sed -n 's/.* \([0-9]\)\..*/\1/p' )
+ GIT_VERSION_MAJOR=$(git --version | sed -E -n 's/.* ([0-9]+)\..*/\1/p' )
if [ 1 -lt "$GIT_VERSION_MAJOR" ];then
git fetch origin "$VCSH_BRANCH"
else
[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
- git init --shared=0600
+ git init --shared=false
upgrade
hook post-init
}
get_files() {
GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
- git ls-files
+ git ls-files --full-name
}
list_tracked() {
use
cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
local GIT_VERSION="$(git --version)"
- local GIT_VERSION_MAJOR=$(echo $GIT_VERSION | sed -n 's/.* \([0-9]\)\..*/\1/p')
- local GIT_VERSION_MINOR=$(echo $GIT_VERSION | sed -n 's/.* \([0-9]\)\.\([0-9]\)\..*/\2/p')
+ local GIT_VERSION_MAJOR=$(echo $GIT_VERSION | sed -E -n 's/.* ([0-9]+)\..*/\1/p')
+ local GIT_VERSION_MINOR=$(echo $GIT_VERSION | sed -E -n 's/.* ([0-9]+)\.([0-9]+)\..*/\2/p')
OLDIFS=$IFS
IFS=$(printf '\n\t')
gitignores=$(for file in $(git ls-files); do